import datetime
from flask import Flask, render_template, jsonify, request

app = Flask(__name__)


@app.context_processor
def inject_now():
    return {"now": datetime.datetime.utcnow()}


@app.errorhandler(404)
def page_not_found(e):
    return render_template("404.html"), 404


@app.route("/")
def index():
    return render_template("index.html")


@app.route("/req", methods=["GET", "POST"])
def detailed():
    return render_template("request.html")


@app.route("/json", methods=["GET", "POST"])
def detailed_json():
    data = dict(
        headers={str(k): str(v) for k, v in request.headers},
        get={k: request.args.getlist(k) for k in request.args},
        post={k: request.form.getlist(k) for k in request.form},
        form_data=request.form,
        json_data=request.get_json() if request.is_json else None
    )
    return jsonify(data)



if __name__ == "__main__":
    app.run()
